{ khscodesLib, inputs }:
{ lib, config, ... }:
let
  cfg = config.khscodes.openbao;
  modules = [
    ./output.nix
    ./vault_mount.nix
  ];
in
{
  options.khscodes.openbao = {
    enable = lib.mkEnableOption "Enables the openbao provider";
  };

  imports = lib.lists.map (m: import m { inherit khscodesLib inputs; }) modules;

  config = lib.mkIf cfg.enable {
    provider.vault = {
      address = "https://auth.kaareskovgaard.net";
    };
    terraform.required_providers.vault = {
      source = "hashicorp/vault";
      version = "5.0.0";
    };
    resource.vault_mount = lib.mapAttrs' (
      name: value: {
        name = khscodesLib.sanitize-terraform-name name;
        value = value;
      }
    );
  };
}
