{
  inputs,
  pkgs,
}:
pkgs.writeShellApplication {
  name = "pre-provisioning";
  runtimeInputs = [
    pkgs.nix
    pkgs.khscodes.bw-opentofu
  ];
  # TODO: Use secret source and required secrets to set up the correct env variables
  text = ''
    hostname="$1"
    baseAttr='${inputs.self}#nixosConfigurations."'"$hostname"'".config.khscodes.provisioning'
    config="$(nix eval --raw "''${baseAttr}.preConfig")"
    secretsSource="$(nix eval --raw "''${baseAttr}.pre.secretsSource")"
    if [[ "$config" == "null" ]]; then
      echo "No preprovisioning needed"
      exit 0
    fi
    if [[ "$secretsSource" == "vault" ]]; then
      >&2 echo "Provisioning using vault is not yet implemented"
      exit 1
    fi
    bw-opentofu "$hostname" "$config" "pre"
  '';
}
